#ifndef CSPLLIB
#define CSPLLIB

#include <windows.h>
/**************************************************************************************
Constants GetMapAddress
**************************************************************************************/
extern DWORD START_ADDRESS;
extern DWORD DIM_ADDRESS;
extern DWORD DimPattern;
extern LPCTSTR SCNFileName;
extern BYTE ACTIVITY_FLAG; 
extern LPCTSTR TitleCSPL;
extern LPCTSTR AuthorString;
//Data for sizing CSPL Main Window
//int XWindow=600;int YWindow=10;int Width=400;int Height=50;
extern int XWindow;extern int YWindow;extern int Width;extern int Height;
/**************************************************************************************
Constants defined
**************************************************************************************/
//BYTE VALUES
#define NONE				0xFF
//BUTTON
#define YES_BTN 6
#define NO_BTN 7
//TERRAINS
#define TERRAIN_OCEAN		0x0A
#define TERRAIN_DESERT		0x00
#define TERRAIN_PLAINS		0x01
#define TERRAIN_GRASSLAND	0x02
#define TERRAIN_FOREST		0x03
#define TERRAIN_HILLS		0x04
#define TERRAIN_MOUNTAINS	0x05
#define TERRAIN_TUNDRA		0x06
#define TERRAIN_GLACIER		0x07
#define TERRAIN_SWAMP		0x08
#define TERRAIN_JUNGLE		0x09
#define TERRAIN_NORESOURCE	0x40
#define TERRAIN_RIVER		0x80
//WONDERS
#define ID_WOND_PYRAMIDS 0
#define ID_WOND_HANGINGARDEN 1
#define ID_WOND_COLOSSUS 2
#define ID_WOND_LIGHTHOUSE 3
#define ID_WOND_GREATLIBRARY 4
#define ID_WOND_ORACLE 5
#define ID_WOND_GREATWALL 6
#define ID_WOND_SUNTZU 7
#define ID_WOND_KINGRICHARD 8
#define ID_WOND_MARCOPOLO 9
#define ID_WOND_MICHELANGELO 10
#define ID_WOND_COPERNICUSOBS 11
#define ID_WOND_MAGELLAN 12
#define ID_WOND_SHAKESPEARE 13
#define ID_WOND_LEONARDO 14
#define ID_WOND_JSBACH 15
#define ID_WOND_NEWTONCOLLEGE 16
#define ID_WOND_ADAMSMITH 17
#define ID_WOND_DARWINVOYAGE 18
#define ID_WOND_STATUELIBERTY 19
#define ID_WOND_EIFFELTWR 20
#define ID_WOND_WOMENSUFFRAGE 21
#define ID_WOND_HOOVERDAM 22
#define ID_WOND_MANHATTANPRJ 23
#define ID_WOND_UN 24
#define ID_WOND_APOLLO 25
#define ID_WOND_SETI 26
#define ID_WOND_CURECANCER 27

//BARBARIAN ACTIVITY
#define BA_RAGING	3
#define BA_RESTLESS	2
#define BA_ROVING	1
#define BA_VILLAGES	0

//MAPS
#define MAP_0 0
#define MAP_1 1
#define MAP_2 2
#define MAP_3 3

// CIVS
#define CIV_BARBARIAN 0
#define CIV_WHITE	1
#define CIV_GREEN	2
#define CIV_BLUE	3
#define CIV_YELLOW	4
#define CIV_CYAN	5
#define CIV_ORANGE	6
#define CIV_PURPLE	7

//DIFFICULTY
#define DIF_DEITY		5
#define DIF_EMPEROR		4
#define DIF_KING		3
#define DIF_PRINCE		2
#define DIF_WARLORD		1
#define DIF_CHIEFTAIN	0
//UNITS
#define UNIT_SETTLER	0
#define UNIT_ENGINEER	1
#define UNIT_WARRIOR	2
#define UNIT_PHALANX	3
#define UNIT_ARCHERS	4
#define UNIT_LEGION		5
#define UNIT_PIKEMEN	6
#define UNIT_MUSKETEERS	7
#define UNIT_FANATICS	8
#define UNIT_PARTISANS	9
#define UNIT_ALPINE		10
#define UNIT_RIFLEMEN	11
#define UNIT_MARINES	12
#define UNIT_PARATRP	13
#define UNIT_MECHINF	14
#define UNIT_HORSEMEN	15
#define UNIT_CHARIOT	16
#define UNIT_ELEPHANT	17
#define UNIT_CRUSADERS	18
#define UNIT_KNIGHTS	19
#define UNIT_DRAGOON	20
#define UNIT_CAVALRY	21
#define UNIT_ARMOR		22
#define UNIT_CATAPULT	23
#define UNIT_CANNON		24
#define UNIT_ARTILLERY  25
#define UNIT_HOWITZER	26
#define UNIT_FIGHTER	27
#define UNIT_BOMBER		28
#define UNIT_HELICPT	29
#define UNIT_STLFTR		30
#define UNIT_STLBMBR	31
#define UNIT_TRIREME	32
#define UNIT_CARAVEL	33
#define UNIT_GALLEON	34
#define UNIT_FRIGATE	35
#define UNIT_IRONCLAD	36
#define UNIT_DESTROYER	37
#define UNIT_CRUISER	38
#define UNIT_AEGIS		39
#define UNIT_BTLSHIP	40
#define UNIT_SUB		41
#define UNIT_CARRIER	42
#define UNIT_TRANSPORT	43
#define UNIT_CRUISE		44
#define UNIT_NUCLEAR	45
#define UNIT_DIPLOMAT	46
#define UNIT_SPY		47
#define UNIT_CARAVAN	48
#define UNIT_FREIGHT	49
#define UNIT_EXPLORER	50
#define UNIT_EXTLAND	51
#define UNIT_EXTSHIP	52
#define UNIT_EXTAIR		53
#define UNIT_A			54
#define UNIT_B			55
#define UNIT_C			56
#define UNIT_D			57
#define UNIT_E			58
#define UNIT_F			59
#define UNIT_G			60
#define UNIT_H			61
#define UNIT_I			62
#define UNIT_J			63
#define UNIT_K			64
#define UNIT_L			65
#define UNIT_M			66
#define UNIT_N			67
#define UNIT_O			68
#define UNIT_P			69
#define UNIT_Q			70
#define UNIT_R			71
#define UNIT_S			72
#define UNIT_T			73
#define UNIT_U			74
#define UNIT_V			75
#define UNIT_W			76
#define UNIT_X			77
#define UNIT_Y			78
#define UNIT_Z			79

// IMPROVE FLAG
#define IMPROVE_NOTHING		1
#define IMPROVE_PALACE		2
#define IMPROVE_BARRACKS	4
#define IMPROVE_GRANARY		8
#define IMPROVE_TEMPLE		16
#define IMPROVE_MARKETPLACE	32
#define IMPROVE_LIBRARY		64
#define IMPROVE_COURTHOUSE	128
#define IMPROVE_CITYWALLS	1
#define IMPROVE_ACQUEDUCT	2
#define IMPROVE_BANK		4
#define IMPROVE_CATHEDRAL	8
#define IMPROVE_UNIVERSITY	16
#define IMPROVE_MASSTRANSIT	32
#define IMPROVE_COLOSSEUM	64
#define IMPROVE_FACTORY		128
#define IMPROVE_MFGPLANT	1
#define IMPROVE_SDI			2
#define IMPROVE_RECYCLCTR	4
#define IMPROVE_PWRPLANT	8
#define IMPROVE_HYDROPLANT	16
#define IMPROVE_NUCLPLANT	32
#define IMPROVE_STOCKEXC	64
#define IMPROVE_SEWER		128
#define IMPROVE_SUPERMKT	1
#define IMPROVE_HIGHWAYS	2
#define IMPROVE_RESLAB		4
#define IMPROVE_SAMBATTERY	8
#define IMPROVE_CFORTRESS	16
#define IMPROVE_SOLARPLANT	32
#define IMPROVE_HARBOR		64
#define IMPROVE_OFFSHORE	128
#define IMPROVE_AIRPORT		1
#define IMPROVE_POLICE		2
#define IMPROVE_PORT		4
#define IMPROVE_TRANSPORTER	8
#define IMPROVE_STRUCTURAL	16
#define IMPROVE_COMPONENT	32
#define IMPROVE_MODULE		64
#define IMPROVE_CAPITALIZATION 128

// BUILD VALUE
#define BUILD_PALACE		0xFF
#define BUILD_BARRACKS		0xFE
#define BUILD_GRANARY		0xFD
#define BUILD_TEMPLE		0xFC
#define BUILD_MARKETPLACE	0xFB
#define BUILD_LIBRARY		0xFA
#define BUILD_COURTHOUSE	0xF9
#define BUILD_CITYWALLS		0xF8
#define BUILD_ACQUEDUCT		0xF7
#define BUILD_BANK			0xF6
#define BUILD_CATHEDRAL		0xF5
#define BUILD_UNIVERSITY	0xF4
#define BUILD_MASSTRANSIT	0xF3
#define BUILD_COLOSSEUM		0xF2
#define BUILD_FACTORY		0xF1
#define BUILD_MFGPLANT		0xF0
#define BUILD_SDI			0xEF
#define BUILD_RECYCLCTR		0xEE
#define BUILD_PWRPLANT		0xED
#define BUILD_HYDROPLANT	0xEC
#define BUILD_NUCLPLANT		0xEB
#define BUILD_STOCKEXC		0xEA
#define BUILD_SEWER			0xE9
#define BUILD_SUPERMKT		0xE8
#define BUILD_HIGHWAYS		0xE7
#define BUILD_RESLAB		0xE6
#define BUILD_SAMBATTERY	0xE5
#define BUILD_CFORTRESS		0xE4
#define BUILD_SOLARPLANT	0xE3
#define BUILD_HARBOR		0xE2
#define BUILD_OFFSHORE		0xE1
#define BUILD_AIRPORT		0xE0
#define BUILD_POLICE		0xDF
#define BUILD_PORT			0xDE
#define BUILD_TRANSPORTER	0xDD
#define BUILD_STRUCTURAL	0xDC
#define BUILD_COMPONENT		0xDB
#define BUILD_MODULE		0xDA
#define BUILD_CAPITALIZATION 0xD9
#define BUILD_PYRAMIDS		0xD8
#define BUILD_HANGINGARDEN	0xD7
#define BUILD_COLOSSUS		0xD6
#define BUILD_LIGHTHOUSE	0xD5
#define BUILD_GREATLIBRARY	0xD4
#define BUILD_ORACLE		0xD3
#define BUILD_GREATWALL		0xD2
#define BUILD_SUNTZU		0xD1
#define BUILD_KINGRICHARD	0xD0
#define BUILD_MARCOPOLO		0xCF
#define BUILD_MICHELANGELO	0xCE
#define BUILD_COPERNICUSOBS	0xCD
#define BUILD_MAGELLAN		0xCC
#define BUILD_SHAKESPEARE	0xCB
#define BUILD_LEONARDO		0xCA
#define BUILD_JSBACH		0xC9
#define BUILD_NEWTONCOLLEGE	0xC8
#define BUILD_ADAMSMITH		0xC7
#define BUILD_DARWINVOYAGE	0xC6
#define BUILD_STATUELIBERTY	0xC5
#define BUILD_EIFFELTWR		0xC4
#define BUILD_WOMENSUFFRAGE	0xC3
#define BUILD_HOOVERDAM		0xC2
#define BUILD_MANHATTANPRJ	0xC1
#define BUILD_UN			0xC0
#define BUILD_APOLLO		0xBF
#define BUILD_SETI			0xBE
#define BUILD_CURECANCER	0xBD


// THREAD ACTIVATION
#define ACTIVATE_UNIT 1
#define ACTIVATE_CITY 2
#define ACTIVATE_CIV 4
#define ACTIVATE_WONDER 8
#define ACTIVATE_GLOBAL 16
#define ACTIVATE_MAP 32
#define ACTIVATE_ATTACK 128

//TRADE GOODS
#define TRADE_HIDES		0x00
#define TRADE_WOOL		0x01
#define TRADE_BEADS		0x02
#define TRADE_CLOTH		0x03
#define TRADE_SALT		0x04
#define TRADE_COAL		0x05
#define TRADE_COPPER	0x06
#define TRADE_DYE		0x07
#define TRADE_WINE		0x08
#define TRADE_SILK		0x09
#define TRADE_SILVER	0x0A
#define TRADE_SPICE		0x0B
#define TRADE_GEMS		0x0C
#define TRADE_GOLD		0x0D
#define TRADE_OIL		0x0E
#define TRADE_URANIUM	0x0F
#define TRADE_FOOD		0xF0

struct Position
{WORD x;
WORD y;
WORD z;
};

struct Unit
{Position pos;
bool Veteran;
byte Type;
byte Owner;
byte HealthLost;
byte MoveLost;  
byte FuelUsed; 
byte Commodity; //It has only sense with Caravan units
byte Orders;
byte HomeCity;
Position Goto;
WORD ID;
};


struct City
{Position pos;
DWORD Flag;
byte Owner;
byte Size;
byte Founder;
DWORD Specialists;
WORD Food;
WORD Production;
WORD NetTrade;
char Name[16];
byte WorkerInner; 
byte Worker8;
byte Worker4;
byte NrSpecialists;
byte Improve[5];
byte ItemProduction;
byte TradeRouteNr;
byte Ava1Comm;
byte Ava2Comm;
byte Ava3Comm;
byte Dem1Comm;
byte Dem2Comm;
byte Dem3Comm;
byte Rou1Comm;
byte Rou2Comm;
byte Rou3Comm;
byte Partn1Id;
byte Partn2Id;
byte Partn3Id;
WORD Science;
WORD Tax;
WORD Trade;
byte FoodProd;
byte ShieldProd;
byte Happy;
byte Unhappy;
WORD ID;
};

struct Wonder
{WORD CityID;
};

struct Global
{WORD Turn;
//XSelected,YSelected,UnitSelected,CitySelected,XDim,YDim
DWORD XSelected;
DWORD YSelected;
WORD IDUnitSelected;
WORD IDCitySelected;
byte CivActive;
WORD XDim;
WORD YDim;
bool CityScreen; //Error, not always it works
bool UnitSelected;
byte CivsInPlay;
byte HumanCivs;
byte Pollution;
byte PeaceTurns;
};

struct Tribe
{byte Style;
char Leader[24];
char Name[24];
char Adjective[24];
};

struct Tile
{	
byte Terrain;
byte Improvements;
byte Radii;
byte BodyCounter;
byte Explored;
byte Sixth;
};

struct Civ
{Tribe Names;
byte Gender;
DWORD Money;
byte Research;
WORD TechResearched;
byte PercentageScience;
byte PercentageTax;
byte Government;
DWORD Treaty[8];
byte Attitude[8];
byte Techs[15];
WORD Demographics;
WORD LastContact[7];
byte Reputation;
};

struct TilesBox
{Tile Elem[3][3];};

//Military units functions
void DeleteUnit();
void WriteUnit(Unit Prova);
bool ReadNextUnit(Unit* unita);
bool ReadNextUnit(Unit* unita,DWORD* UnitCounter);
bool CreateUnit(Unit Prova2);
bool UnitAt(DWORD x,DWORD y,DWORD z,DWORD Offset,Unit* Prova);
bool UnitType(DWORD Type,DWORD Offset,Unit* Prova);
bool UnitID(DWORD Id,Unit* Prova);
bool ReWriteUnit(Unit Prova,DWORD Id);
void ResetUnit();
void ResetUnit(DWORD* UnitCounter);

//Global Functions
void RefreshMap();
void Refresh();
void EmulateKey(char r);
BYTE pwr(int exp); //Calculates 2^exp
bool Initialize();
void GlobalCheck();
void StillActive();//IT DOESN'T WORK!
DWORD GetMapAddress(byte* Pattern); 
void ReadPattern(byte* Pattern);

//City functions
void ResetCity();
void ResetCity(DWORD* CityCounter);
bool ReadNextCity(City* unita);
bool ReadNextCity(City* unita,DWORD* CityCounter);
void DeleteCity();
void WriteCity(City Prova);
bool CreateCity(City Prova2);
bool CityAt(DWORD x,DWORD y,DWORD z,DWORD Offset,City* Prova);
bool CityID(DWORD Id,City* Prova);
bool ReWriteCity(City Prova,DWORD Id);
bool CityName(LPSTR Name,DWORD Offset,City* Prova);

//Map functions
DWORD OffsetMap(int x, int y);
byte GetTerrain(int x,int y);
void GetTile(Tile* Casella,int x,int y);
void SetTile(Tile* Casella,int x,int y);
void Get9Tiles(TilesBox* Box,int x, int y);


//Civ functions
bool ReadNextCiv(Civ* Civilta);
bool ReadNextCiv(Civ* Civilta,DWORD* CivCounter1,DWORD* CivCounter2);
bool CivID(int ID,Civ* Prova);
void ResetCiv();
void ResetCiv(DWORD* CivCounter1,DWORD* CivCounter2);
bool ReWriteCiv(Civ Prova,int ID);
void DeleteCiv(int ID);
void WriteCiv(Civ Prova);
BOOL TestCiv(int ID);
  
//Wonder functions
WORD GetCityWonder(int Wonder);
bool SetCityWonder(WORD CityID,int Wonder);
bool DestroyWonder(int Wonder);
bool DeleteWonder(int Wonder);

//Global Civ functions
WORD TurnPassed();
byte GetDifficulty();
byte SetDifficulty(int Level);
byte GetBarbarianActivity();
byte SetBarbarianActivity(byte Activity);
byte GetCurrentCiv();
void SetCurrentCiv(byte current);
WORD GetCurrentUnit();
void SetCurrentUnit(WORD Id);
byte GetCivInPlay();
void CreateCiv(int ID);
void SetHumanPlayer(byte Civs);
byte GetHumanPlayer();
byte ReadCurrentPollution();
void WriteCurrentPollution(byte Level);
byte PeaceTurns();

LRESULT CALLBACK WndProc(HWND hWnd,UINT imessage, WPARAM wParam,LPARAM lParam);



//Thread functions
void UnitCycle();
void CityCycle();
void GlobalCycle();
void WonderCycle();
void MapCycle();
void CivCycle();
void AttackCycle();

//User-defined functions
void UnitCheck(Unit Prova);
void CityCheck(City Prova);
void WonderCheck();
void GlbCheck(Global Global1);
void MapCheck();
void CivCheck(Civ Prova);
void KeyboardCheck(char wParam);
void AttackCheck(Unit* Attacker,Unit* Attacked,BOOL Winner);

//GUI functions
void AboutBox();
void AboutScn();
BOOL MessageCSPL(LPCSTR Testo);
int RequestCSPL(LPCSTR Testo);
void InitializeCSPL();

//Dont change this
HINSTANCE MainInstance;

HWND Handle;
DWORD ProcessID;
HANDLE Process;
BOOL CloseProcess=FALSE;

extern int CSPLVersion;
extern int CSPLRelease;

#define IDCSPL 101
#define IDR_MENU1 103
#define ID_MAIN_EXIT 40002
#define ID_MAIN_ABOUT 40001
#define ID_MAIN_ABOUTSCN 40003

#endif