REM PLACE YOUR BORLAND PATH AND CSPL PATH IN THE FOLLOWING BRACKETS 
SET BORLANDPATH=" BORLAND PATH HERE "
SET CSPLPATH=" CSPL PATH HERE "

@ECHO OFF
cd "..\Projects"
:START
CLS
ECHO.
ECHO.
ECHO 				CSPL Companion V 0.2
ECHO -------------------------------------------------------------------------------
ECHO  			By Angelo Scotto (scotto_a@hotmail.com)
ECHO.
 IF NOT "%1"=="" SET PTH="%1"
IF "%1"=="" SET PTH=".\WorkSpace"
ECHO Path currently selected is %PTH%
ECHO.
ECHO Select:
ECHO.
ECHO		1) Prepare template files to write a new CSPLclient program
ECHO.
ECHO		2) Compile and link a previously written CSPLclient program
ECHO.
ECHO		3) Exit from CSPL Companion
ECHO.
IF (%OS%)==(Windows_NT) goto WinXP
choice /C:123
IF ERRORLEVEL 3 GOTO USCITA
IF ERRORLEVEL 2 GOTO COMPILE
IF ERRORLEVEL 1 GOTO NEWTMP

:WinXP
SET /P CHOICE=[1,2,3]?
IF %CHOICE%==1 GOTO USCITA
IF %CHOICE%==2 GOTO COMPILE
IF %CHOICE%==3 GOTO NEWTMP
ECHO Please enter 1, 2 or 3.
GOTO WinXP

:COMPILE
ECHO Remember that your source code name should be CSPLclient.csp and CSPLclient.h
ECHO to allow CSPLCompanion to compile them successfully
ECHO.

REM cd %PTH%
IF NOT EXIST %PTH%\cspl.h COPY %CSPLPATH%\library\cspl.h %PTH%\cspl.h
ECHO %BORLANDPATH%\bin\BCC32 -I%BORLANDPATH%\include -c -P -w- -tW %PTH%\csplclient.csp
IF EXIST %PTH%\csplclient.csp %BORLANDPATH%\bin\BCC32 -I%BORLANDPATH%\include -c -P -w- -tW %PTH%\csplclient.csp
IF EXIST %PTH%\csplclient.cpp %BORLANDPATH%\bin\BCC32 -I%BORLANDPATH%\include -c -w- -tW %PTH%\csplclient.cpp
ECHO COMPILING PHASE ENDED
REM IF NOT EXIST %PTH%\cspl.res COPY %CSPLPATH%\Library\cspl.res %PTH%\cspl.res
REM IF NOT EXIST %PTH%\cspl.lib COPY %CSPLPATH%\Library\cspl.lib %PTH%\cspl.lib
%BORLANDPATH%\bin\ILINK32 -L%BORLANDPATH%\lib /aa c0w32.obj %PTH%\csplclient.obj,%PTH%\csplclient.exe,,%CSPLPATH%\library\cspl.lib import32.lib cw32.lib,,%CSPLPATH%\library\cspl.res
ECHO LINKING PHASE ENDED
ECHO Work finished, Check if there were some errors.
ECHO Now exiting...
GOTO USCITA

:NEWTMP
IF NOT EXIST %PTH% mkdir %PTH%
COPY %CSPLPATH%\Templates\CSPLclient.cpp %PTH%\CSPLclient.csp
COPY %CSPLPATH%\Templates\CSPLclient.h %PTH%\CSPLclient.h
COPY %CSPLPATH%\Library\CSPL.RES %PTH%\CSPL.RES
ECHO.
ECHO Ok,templates copied to directory %PTH%
ECHO Exiting...

:USCITA
SET CHOICE=
CD %CSPLPATH%\tools
